//**********************************************************************
//
//              LCDC16x2.c              LN^[kbcPUQs
//
//**********************************************************************

static void lcdc_write8( char data );
static void lcdc_write4( char data );
void lcdc_init( void );              // kbc
void lcdc_cls( void );               // kbc̉ʃNA
void lcdc_xy( uint8 x, uint8 y );    // kbc̃J[\|WV̐ݒ
void lcdc_setcg( uint8 ch, char * cgdata ); // [U[`  ch:0-7  cgdata:8oCg
void lcdc_putch( char ch );         // kbcɂPo
void lcdc_putstr( char *str );      // kbcɕo


//
// kbc
//
void lcdc_init( void ) {
  dly_usec( 20000 );            // d 15ms ȏ҂
  LCDC_RS_LOW();                // LCD RS = 0  R}h
  lcdc_write4( 0x30 );
  dly_usec( 5000 );             // 4.1ms ȏ҂
  lcdc_write4( 0x30 );
  dly_usec( 5000 );
  lcdc_write4( 0x30 );
  dly_usec( 5000 );
  lcdc_write4( 0x20 );          // Srbg[h
  dly_usec( 5000 );

  lcdc_write8( 0x28 );          // SrbgAQs\ATVhbg
  lcdc_write8( LCDC_NOCURSOR ); // \ ONAJ\[Ȃ
  lcdc_cls();                   // fBXv[NA
}


//
// kbc̉ʃNA
//
void lcdc_cls( void ) {
  lcdc_write8( 0x01 );        // fBXv[NA 
  dly_usec( 2500 );           // ő 1.52ms   VFD ł2.3ms
  x = y = 0;
}


//
// J[\ x,y Ɉړ
//
void lcdc_xy( uint8 lcdx, uint8 lcdy ) {
  uint8 adr;

  x = lcdx;
  if( x>=LCDC_MAX_X ) x=0;
  y = lcdy;
  if( y>=LCDC_MAX_Y ) y=0;
  adr = ((y==1)?0xC0:0x80)+x;
  lcdc_write8( adr );           // Set DDRAM address 
}


//
// [U[`    ch:0-7   cgdata:8oCg
//
void lcdc_setcg( uint8 ch, char * cgdata ) {
  lcdc_write8( 0x40+(ch<<3) );   // CGRAM address set
  LCDC_RS_HIGH();           // LCD RS = 1  f[^
  for( uint8 i=0; i<8; i++ ) {
    lcdc_write8( *cgdata++ );        // rs=1 f[^
  }
  LCDC_RS_LOW();            // LCD RS = 0  R}h
}


//
// Po
//
void lcdc_putch( char ch ) {
  switch( ch ) {
    case  LF:                   // \n = 0x0A J[\si̍sցj
      lcdc_xy( 0, y+1 );
      break;
    default:
      LCDC_RS_HIGH();           // LCD RS = 1  f[^
      lcdc_write8( ch );        // rs=1 f[^
      LCDC_RS_LOW();            // LCD RS = 0  R}h
      lcdc_xy( x+1, y );
      break;
  }
}


//
// o
//
void lcdc_putstr( char *str ) {
  while( *str ) {
    lcdc_putch( *str++ );
  }
}


//
// qnl̕o
//
void lcdc_putstr_p(const prog_char *s) {
    uint8 c;
    while( (c=pgm_read_byte(s++)) != 0 ) lcdc_putch(c);
}


//
// PoCgkbcɑ
//
static void lcdc_write8( char data ) {
  lcdc_write4( (data>>4) );     // ʂSrbgo
  lcdc_write4( data );          // ʂSrbgo
  dly_usec( 100 );              // o͂ɂ鎞
}


//
// ʂSrbgkbcɑ   rs=0 R}h@rs=1 f[^
//
static void lcdc_write4( char data ) {
  uint8 port;
  
  port = LCDC_DATA;              // |[gɏo͂Ăf[^ǂށiAVRLj
  LCDC_DATA = (data&0x0F)|(port&0xF0);
  LCDC_E_HIGH();                 // LCD ENABLE = 1 
  dly_usec( 1 );                 // 
  LCDC_E_LOW();                  // LCD ENABLE = 0 
}

