//**********************************************************************
//
//              SG.c         M𐶐c`Ro[^[ɑ
//
//**********************************************************************

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/pgmspace.h>
#include <string.h>
#include <avr/eeprom.h>
#include "sg.h"

extern PARAMSG *paramsg;
extern prog_int16_t *psin2048_tbl;
extern PARAM pa;

// ------------------------------------------------------------------------
// sine eXg Pe[u 
// ------------------------------------------------------------------------
void sine( void ) {
  asm volatile (                // 
      "clr  r2           \n\t"  // 1         { r1 [|ZŎĝ r2 [ƂĎg
      
      "90:               \n\t"  //           while(1) {
    
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - O   4 clk     k ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "sbi   0x0b, 2     \n\t"  // 2              LRCLK_H
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - P   19 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14
      
                                // 17 ʑZPGo
      "movw  r30, %0     \n\t"  //     1          r30:paramsg
      "ldd   r20, Z+4    \n\t"  //     2          tmp=freq1sg_l
      "add   r10, r20    \n\t"  //     1          phase:r12r11r10 += freq1sgh:%3 freq1sg:%2
      "ldd   r20, Z+5    \n\t"  //     2          tmp=freq1sg_m
      "adc   r11, r20    \n\t"  //     1          
      "ldd   r20, Z+3    \n\t"  //     2          tmp=freq1sg_h
      "adc   r12, r20    \n\t"  //     1          
      "mov   r30, r12    \n\t"  //     1          if( phaseh:r12 & 0x04 ) {
      "andi  r30, 0x04   \n\t"  //     1          
      "brne  1f          \n\t"  //     1  2       
      "cbi   0x05, 1     \n\t"  //     2             PG_H
      "rjmp  2f          \n\t"  //     2
      "1:                \n\t"  //                }else{
      "sbi   0x05, 1     \n\t"  //        2          PG_L;
      "nop               \n\t"  //        1
      "2:                \n\t"  //                }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - Q   25 clk
      "sts  0x00C6, r13  \n\t"  // 2              UDR0 = d1:r13
      
                                // 19  sin( phaseh ) => r19r18 r17r16
      "mov   r30, r11    \n\t"  //     1          phaseh:r12r11 =  upper 11bits of phase
      "mov   r31, r12    \n\t"  //     1          
      "andi  r31, 0x07   \n\t"  //     1          Ȃrbg}XN
      "add   r30, r30    \n\t"  //     1          
      "adc   r31, r31    \n\t"  //     1          phaseh*2
      "add   r30, %A1    \n\t"  //     1          psin256h_tbl
      "adc   r31, %B1    \n\t"  //     1          
      "lpm   r18, Z+     \n\t"  //     3          sin( phaseh ):r19r18
      "lpm   r19, Z+     \n\t"  //     3          
      "lpm   r16, Z+     \n\t"  //     3          sin( phaseh+1 ):r17r16
      "lpm   r17, Z+     \n\t"  //     3          
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - R   16clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 11 sin( phaseh ) + d * phasel / 256
      "mov   r20, r10    \n\t"  //     1          r20=phasel
      "sub   r16, r18    \n\t"  //     1          d = sin( phaseh+1 ) - sin( phaseh )
      "sbc   r17, r19    \n\t"  //     1          
      "mulsu r17, r20    \n\t"  //     2          d * phasel
      "add   r18, r0     \n\t"  //     1          data = sin( phaseh ) + d * phasel / 256
      "adc   r19, r1     \n\t"  //     1          
      "mul   r16, r10    \n\t"  //     2          
      "add   r18, r1     \n\t"  //     1          
      "adc   r19, r2     \n\t"  //     1          
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - S   16clk     q ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "cbi   0x0b, 2     \n\t"  // 2              LRCLK_L;   
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - T   16clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14     
      "movw  r30, %0     \n\t"  // 1              r30:paramsg
      "ldd   r16, Z+1    \n\t"  // 2              r16:levelsg_l
      "ldd   r17, Z+2    \n\t"  // 2              r17:levelsg_h
      "ld    r20, Z      \n\t"  // 2              r20:level256
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - U   4 clk
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13 
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - V   28 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 20  level control  data:r19r18 * levelsg:%1 => d3:r15 d2:r13 d1:r14
      "mulsu r19, r17    \n\t"  //     2          levelsg_h
      "and   r20, r20    \n\t"  //     1          if level256(XP[OtO)==1 
      "breq  1f          \n\t"  //     1  2             
      "mov   r14,  r1    \n\t"  //     1                
      "mov   r13,  r0    \n\t"  //     1                
      "mul   r18, r17    \n\t"  //     2                levelsg_h
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mulsu r19, r16    \n\t"  //     2                levelsg_l
      "sbc   r14,  r2    \n\t"  //     1                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mov   r15,  r14   \n\t"  //     1                d2 ̕Ƃ肾
      "add   r15,  r15   \n\t"  //     1                
      "sbc   r15,  r15   \n\t"  //     1                d3 = 
      "rjmp  2f          \n\t"  //     2                
      "1:                \n\t"  //                }else{      XP[OȂꍇ
      "movw  r14,  r0    \n\t"  //        1             
      "mul   r18, r16    \n\t"  //        2             levelsg_l
      "mov   r13,  r1    \n\t"  //        1             
      "mul   r18, r17    \n\t"  //        2             levelsg_h
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "mulsu r19, r16    \n\t"  //        2             levelsg_l
      "sbc   r15,  r2    \n\t"  //        1             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "2:                \n\t"  //                }
      
                                // 4  SW͂H
      "in    r16, 0x09   \n\t"  //     1          sw:r21=~(uint8)SW_PORT:0x09
      "com   r16         \n\t"  //     1
      "andi  r16, 0xE8   \n\t"  //     1          sw:r21 &= SW_MASK:0xE8
      "brne  99f         \n\t"  //     1  2       if( sw ) return
      
      "rjmp  90b         \n\t"  // 2         } jmp while(1)
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - while [v̏I
      "99:               \n\t"  //                return
      "clr   r1          \n\t"  // 1              r1=0 ɖ߂
      : 
      : "r"(paramsg), "r"(psin2048_tbl) //, "a"(levelsg), "r"(freq1sg), "r"(freq1sgh), "r"(psin2048_tbl), "r"(freq2sg), "r"(freq2sgh)
      : "r0", "r1",               // |Ž
        "r2",                     // zero
        "r12", "r11", "r10",      // phase
        "r15", "r14", "r13",      // d3, d2, d1
        "r17", "r16",             // sin(phasel)
        "r19", "r18",             // data
        "r20",                    // tmp
        "r30", "r31"              // Z
  );
}


// ------------------------------------------------------------------------
// whitenoise   UZăKEXmCYɋ߂Â
// ------------------------------------------------------------------------
void whitenoise( void ) {
  asm volatile (
      "movw  r30, %0     \n\t"  // 1              r30:paramsg
      "ldd   r22, Z+1    \n\t"  // 2              r22:levelsg_l
      "ldd   r23, Z+2    \n\t"  // 2              r23:levelsg_h
      "ld    r3,  Z      \n\t"  // 2              r3:level256
      "ldi   r16, 173    \n\t"  // 2              rndmulti:r4 = 173
      "mov   r4,  r16    \n\t"  // 2              
      
      "clr  r2           \n\t"  // 1         { r1 [|ZŎĝ r2 [ƂĎg
      "90:               \n\t"  //           while(1) {
    
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - O   15clk     k ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "sbi   0x0b, 2     \n\t"  // 2              LRCLK_H
      
                                // 11 mCY
      "mul   r17, r4     \n\t"  //     2          rnd:r17.r16 *= 173:r4
      "mov   r21, r0     \n\t"  //     1          tmp:r21
      "mul   r16, r4     \n\t"  //     2              
      "movw  r16, r0     \n\t"  //     1              
      "add   r17, r21    \n\t"  //     1              
      "subi  r16, 0xFF   \n\t"  //     1          rnd++
      "sbci  r17, 0xFF   \n\t"  //     1          
      "movw  r18, r16    \n\t"  //     1          noise:r19r18 = rnd:r17r16 ŏ
      "clr   r20         \n\t"  //     1          nh:r20 = 0
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - P   14clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2;r14
      
                                // 12 mCYɉZ
      "mul   r17, r4     \n\t"  //     2          rnd:r17.r16 *= 173:r4
      "mov   r21, r0     \n\t"  //     1          tmp:r21
      "mul   r16, r4     \n\t"  //     2              
      "movw  r16, r0     \n\t"  //     1              
      "add   r17, r21    \n\t"  //     1              
      "subi  r16, 0xFF   \n\t"  //     1          rnd++
      "sbci  r17, 0xFF   \n\t"  //     1          
      "add   r18, r16    \n\t"  //     1          noise += rnd
      "adc   r19, r17    \n\t"  //     1          
      "adc   r20,  r2    \n\t"  //     1          if carry nh++
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - Q   14clk
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13
      
                                // 12 mCYɉZ
      "mul   r17, r4     \n\t"  //     2          rnd:r17.r16 *= 173:r4
      "mov   r21, r0     \n\t"  //     1          tmp:r21
      "mul   r16, r4     \n\t"  //     2              
      "movw  r16, r0     \n\t"  //     1              
      "add   r17, r21    \n\t"  //     1              
      "subi  r16, 0xFF   \n\t"  //     1          rnd++
      "sbci  r17, 0xFF   \n\t"  //     1          
      "add   r18, r16    \n\t"  //     1          noise += rnd
      "adc   r19, r17    \n\t"  //     1          
      "adc   r20,  r2    \n\t"  //     1          if carry nh++
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - R   21clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 12 mCYɉZ
      "mul   r17, r4     \n\t"  //     2          rnd:r17.r16 *= 173:r4
      "mov   r21, r0     \n\t"  //     1          tmp:r21
      "mul   r16, r4     \n\t"  //     2              
      "movw  r16, r0     \n\t"  //     1              
      "add   r17, r21    \n\t"  //     1              
      "subi  r16, 0xFF   \n\t"  //     1          rnd++
      "sbci  r17, 0xFF   \n\t"  //     1          
      "add   r18, r16    \n\t"  //     1          noise += rnd
      "adc   r19, r17    \n\t"  //     1          
      "adc   r20,  r2    \n\t"  //     1          if carry nh++
      
                                // 7 mCYɉZ 1/2
      "mul   r17, r4     \n\t"  //     2          rnd:r17.r16 *= 173:r4
      "mov   r21, r0     \n\t"  //     1          tmp:r21
      "mul   r16, r4     \n\t"  //     2              
      "movw  r16, r0     \n\t"  //     1              
      "add   r17, r21    \n\t"  //     1              
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - S   10 clk     q ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3;r15
      "cbi   0x0b, 2     \n\t"  // 2              LRCLK_L;   
      
                                // 5 mCYɉZ 2/2
      "subi  r16, 0xFF   \n\t"  //     1          rnd++
      "sbci  r17, 0xFF   \n\t"  //     1          
      "add   r18, r16    \n\t"  //     1          noise += rnd
      "adc   r19, r17    \n\t"  //     1          
      "adc   r20,  r2    \n\t"  //     1          if carry nh++
      
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - T   14 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2;r14
    
                                // 12 mCYɉZ
      "mul   r17, r4     \n\t"  //     2          rnd:r17.r16 *= 173:r4
      "mov   r21, r0     \n\t"  //     1          tmp:r21
      "mul   r16, r4     \n\t"  //     2              
      "movw  r16, r0     \n\t"  //     1              
      "add   r17, r21    \n\t"  //     1              
      "subi  r16, 0xFF   \n\t"  //     1          rnd++
      "sbci  r17, 0xFF   \n\t"  //     1          
      "add   r18, r16    \n\t"  //     1          noise += rnd
      "adc   r19, r17    \n\t"  //     1          
      "adc   r20,  r2    \n\t"  //     1          if carry nh++
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - U   12 clk
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:;r13
      
                                // 10 SrbgVtgďo̓f[^
                                //                when nh:r20=01, noise:r19.r18=2345
      "swap  r20         \n\t"  //     1          r20 = 10
      "swap  r19         \n\t"  //     1          r19 = 32
      "swap  r18         \n\t"  //     1          r18 = 54
      "mov   r21, r19    \n\t"  //     1          tmp:r21 = 32
      "andi  r19, 0x0F   \n\t"  //     1          r19 = 02
      "or    r19, r20    \n\t"  //     1          r19 = 12
      "andi  r18, 0x0F   \n\t"  //     1          r18 = 04
      "andi  r21, 0xF0   \n\t"  //     1          r21 = 30
      "or    r18, r21    \n\t"  //     1          r18 = 34
      "subi  r19, 0x30   \n\t"  //     1          r19 -= 30@mCY 0x3000 ăZ^[[ɂ
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - V   28 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 20  level control  data:r19r18 * levelsg:r23r22 => d3:r15 d2:r13 d1:r14
      "mulsu r19, r23    \n\t"  //     2          levelsg_h
      "and   r3 , r3     \n\t"  //     1          if level256(XP[OtO):r3==1 
      "breq  1f          \n\t"  //     1  2             
      "mov   r14,  r1    \n\t"  //     1                
      "mov   r13,  r0    \n\t"  //     1                
      "mul   r18, r23    \n\t"  //     2                levelsg_h
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mulsu r19, r22    \n\t"  //     2                levelsg_l
      "sbc   r14,  r2    \n\t"  //     1                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mov   r15,  r14   \n\t"  //     1                d2 ̕Ƃ肾
      "add   r15,  r15   \n\t"  //     1                
      "sbc   r15,  r15   \n\t"  //     1                d3 = 
      "rjmp  2f          \n\t"  //     2                
      "1:                \n\t"  //                }else{      XP[OȂꍇ
      "movw  r14,  r0    \n\t"  //        1             
      "mul   r18, r22    \n\t"  //        2             levelsg_l
      "mov   r13,  r1    \n\t"  //        1             
      "mul   r18, r23    \n\t"  //        2             levelsg_h
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "mulsu r19, r22    \n\t"  //        2             levelsg_l
      "sbc   r15,  r2    \n\t"  //        1             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "2:                \n\t"  //                }
      
                                // 4  SW͂H
      "in    r21, 0x09   \n\t"  //     1          sw:r21=~(uint8)SW_PORT:0x09
      "com   r21         \n\t"  //     1
      "andi  r21, 0xE8   \n\t"  //     1          sw:r21 &= SW_MASK:0xE8
      "brne  99f         \n\t"  //     1  2       if( sw ) return
      
      "rjmp  90b         \n\t"  // 2         } jmp while(1)
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - while [v̏I
      "99:               \n\t"  //                return
      "clr   r1          \n\t"  // 1              r1=0 ɖ߂
      : 
      : "r"(paramsg)
      : "r0", "r1",               // |Ž
        "r2",                     // zero
        "r3",                     // level256
        "r4",                     // rndmulti
        "r15", "r14", "r13",      // d3, d2, d1
        "r17", "r16",             // rnd
        "r19", "r18",             // noise
        "r20",                    // nh  noise ̉ZĂ͂ݏo
        "r21",                    // tmp
        "r23", "r22",             // levelsg
        "r31", "r30"              // Z
  );
}



// ------------------------------------------------------------------------
// pinknoise eXg  }0.5dB
// ------------------------------------------------------------------------
void pinknoise_test( void ) {
//
//http://www.firstpr.com.au/dsp/pink-noise/#Filtering
//
//An 'economy' version with accuracy of +/-0.5dB is also available. 
//   b0 = 0.99765 * b0 + white * 0.0990460; 
//   b1 = 0.96300 * b1 + white * 0.2965164; 
//   b2 = 0.57000 * b2 + white * 1.0526913; 
//   tmp = b0 + b1 + b2 + white * 0.1848; 
//
// ㎮u{Rrbg{PQrbgv`ɕϊ
//   b0 = 0x0FF6 * b0 + rnd * 0x0196; 
//   b1 = 0x0F68 * b1 + rnd * 0x04BF; 
//   b2 = 0x091F * b2 + rnd * 0x10D8; 
//   noise = b0 + b1 + b2 + rnd * 0x02F5; 
//
  
  asm volatile (                // 
      "movw  r30, %0     \n\t"  // 1              r30:paramsg
      "ldd   r22, Z+1    \n\t"  // 2              r22:levelsg_l
      "ldd   r23, Z+2    \n\t"  // 2              r23:levelsg_h
      "ld    r3,  Z      \n\t"  // 2              r3:level256
      "ldi   r16, 173    \n\t"  // 2              rndmulti:r4 = 173
      "mov   r4,  r16    \n\t"  // 2              
      
      "clr  r2           \n\t"  // 1         { r1 [|ZŎĝ r2 [ƂĎg
      
      "90:               \n\t"  //           while(1) {
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - O   28 clk     k ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "sbi   0x0b, 2     \n\t"  // 2              LRCLK_H
      
                                // 9    rnd:r17r16
      "mul   r17, r4     \n\t"  //     2          rnd:r17r16 *= 173:r4
      "mov   r30, r0     \n\t"  //     1          tmp:r30
      "mul   r16, r4     \n\t"  //     2          
      "movw  r16, r0     \n\t"  //     1          
      "add   r17, r30    \n\t"  //     1          
      "subi  r16, 0xFF   \n\t"  //     1          rnd++
      "sbci  r17, 0xFF   \n\t"  //     1          
      
                                // 7  |P`{Pɂ r27r26 ɂ
      "movw  r26, r16    \n\t"  //     1          ZpRrbgEVtg
      "asr   r27         \n\t"  //     1          
      "ror   r26         \n\t"  //     1          
      "asr   r27         \n\t"  //     1          
      "ror   r26         \n\t"  //     1          
      "asr   r27         \n\t"  //     1          
      "ror   r26         \n\t"  //     1          
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - P   23 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2;r14
      
      // ǑvZ@b0 = 0x0FF6 * b0 + rnd * 0x0196
      
                                // 21 tmp:r31r30r29 = b0:r7r6 * 0x0FF6:r19r18
      "movw  r20, r6     \n\t"  //     1          tmp:r21r20 = b0
      "ldi   r19, 0x0F   \n\t"  //     1          
      "ldi   r18, 0xF6   \n\t"  //     1          
      "muls  r21, r19    \n\t"  //     2          hb0:r21 * 0x0F:r19
      "movw  r30, r0     \n\t"  //     1          tmp:r31.r30
      "mul   r20, r18    \n\t"  //     2          lb0:r20 * 0xF6:r18
      "mov   r29, r1     \n\t"  //     1          tmp:r29
      "mulsu r21, r18    \n\t"  //     2          hb0:r21 * 0xF6:r18
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      "mulsu r19, r20    \n\t"  //     2          0x0F:r19 * lb0:r20
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - Q   36 clk
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13
      
                                // 24 tmp:r31r30r29 += rnd8:r27r26 * 0x0196:r19r18
      "movw  r20, r26    \n\t"  //     1          
      "ldi   r19, 0x01   \n\t"  //     1          
      "ldi   r18, 0x96   \n\t"  //     1          
      "muls  r21, r19    \n\t"  //     2          hb0:r21 * 0x0F:r19
      "add   r30, r0     \n\t"  //     1          
      "adc   r31, r1     \n\t"  //     1          
      "mul   r20, r18    \n\t"  //     2          lb0:r20 * 0xF6:r18
      "add   r29, r1     \n\t"  //     1          tmp:r29
      "adc   r30, r2     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      "mulsu r21, r18    \n\t"  //     2          hb0:r21 * 0xF6:r18
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      "mulsu r17, r20    \n\t"  //     2          0x0F:r17 * lb0:r20
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      
      
                                // 10 b0:r7r6 = (tmp:r31r30r29)>>4
      "ldi   r18, 0x10   \n\t"  //     1          
      "mul   r30, r18    \n\t"  //     2          
      "movw  r6 , r0     \n\t"  //     1          
      "mul   r31, r18    \n\t"  //     2          
      "or    r7 , r0     \n\t"  //     1          
      "mul   r29, r18    \n\t"  //     2          
      "or    r6 , r1     \n\t"  //     1          
      
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - R   41 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
      // P̌vZ@b1 = 0x0F68 * b1 + rnd * 0x04BF
      
                                // 21 tmp:r31r30r29 = b1:r9r8 * 0x0F68:r19r18
      "movw  r20, r8     \n\t"  //     1          tmp:r21r20 = b0
      "ldi   r19, 0x0F   \n\t"  //     1          
      "ldi   r18, 0x68   \n\t"  //     1          
      "muls  r21, r19    \n\t"  //     2          hb0:r21 * 0x0F:r19
      "movw  r30, r0     \n\t"  //     1          tmp:r31.r30
      "mul   r20, r18    \n\t"  //     2          lb0:r20 * 0x68:r18
      "mov   r29, r1     \n\t"  //     1          tmp:r29
      "mulsu r21, r18    \n\t"  //     2          hb0:r21 * 0x68:r18
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      "mulsu r19, r20    \n\t"  //     2          0x0F:r19 * lb0:r20
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      
                                // 18 tmp:r31r30r29 += rnd8:r27r26 * 0x04BF:r19r18
      "movw  r20, r26    \n\t"  //     1          
      "ldi   r19, 0x04   \n\t"  //     1          
      "ldi   r18, 0xBF   \n\t"  //     1          
      "muls  r21, r19    \n\t"  //     2          hb0:r21 * 0x0F:r19
      "add   r30, r0     \n\t"  //     1          
      "adc   r31, r1     \n\t"  //     1          
      "mul   r20, r18    \n\t"  //     2          lb0:r20 * 0xF6:r18
      "add   r29, r1     \n\t"  //     1          tmp:r29
      "adc   r30, r2     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      "mulsu r21, r18    \n\t"  //     2          hb0:r21 * 0xF6:r18
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      
  // -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- S   28 clk     q ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "cbi   0x0b, 2     \n\t"  // 2              LRCLK_L;   
      
                                // 6  Â tmp:r31r30r29 += rnd8:r27r26 * 0x0196:r19r18
      "mulsu r17, r20    \n\t"  //     2          0x0F:r17 * lb0:r20
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      
                                // 10 b1:r9r8 = (tmp:r31r30r29)>>4
      "ldi   r18, 0x10   \n\t"  //     1          
      "mul   r30, r18    \n\t"  //     2          
      "movw  r8 , r0     \n\t"  //     1          
      "mul   r31, r18    \n\t"  //     2          
      "or    r9 , r0     \n\t"  //     1          
      "mul   r29, r18    \n\t"  //     2          
      "or    r8 , r1     \n\t"  //     1          
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - T   23 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14     
      
      // Q̌vZ@b2 = 0x091F * b2 + rnd * 0x10D8
      
                                // 21 tmp:r31r30r29 = b2:r11r10 * 0x091F:r19r18
      "movw  r20, r10    \n\t"  //     1          tmp:r21r20 = b2
      "ldi   r19, 0x09   \n\t"  //     1          
      "ldi   r18, 0x1F   \n\t"  //     1          
      "muls  r21, r19    \n\t"  //     2          hb0:r21 * 0x09:r19
      "movw  r30, r0     \n\t"  //     1          tmp:r31.r30
      "mul   r20, r18    \n\t"  //     2          lb0:r20 * 0x1F:r18
      "mov   r29, r1     \n\t"  //     1          tmp:r29
      "mulsu r21, r18    \n\t"  //     2          hb0:r21 * 0x1F:r18
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      "mulsu r19, r20    \n\t"  //     2          0x0F:r19 * lb0:r20
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - U   36 clk
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13 
      
                                // 24 tmp:r31r30r29 += rnd8:r27r26 * 0x10D8:r19r18
      "movw  r20, r26    \n\t"  //     1          
      "ldi   r19, 0x19   \n\t"  //     1          
      "ldi   r18, 0xD8   \n\t"  //     1          
      "muls  r21, r19    \n\t"  //     2          hb0:r21 * 0x0F:r19
      "add   r30, r0     \n\t"  //     1          
      "adc   r31, r1     \n\t"  //     1          
      "mul   r20, r18    \n\t"  //     2          lb0:r20 * 0xF6:r18
      "add   r29, r1     \n\t"  //     1          tmp:r29
      "adc   r30, r2     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      "mulsu r21, r18    \n\t"  //     2          hb0:r21 * 0xF6:r18
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      "mulsu r17, r20    \n\t"  //     2          0x0F:r17 * lb0:r20
      "sbc   r31, r2     \n\t"  //     1          
      "add   r29, r0     \n\t"  //     1          
      "add   r30, r1     \n\t"  //     1          
      "adc   r31, r2     \n\t"  //     1          
      
      
                                // 10 b2:r11r10 = (tmp:r31r30r29)>>4
      "ldi   r18, 0x10   \n\t"  //     1          
      "mul   r30, r18    \n\t"  //     2          
      "movw  r10, r0     \n\t"  //     1          
      "mul   r31, r18    \n\t"  //     2          
      "or    r11, r0     \n\t"  //     1          
      "mul   r29, r18    \n\t"  //     2          
      "or    r10, r1     \n\t"  //     1          
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - V   41 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 5 noise:r19r18 = b0 + b1 + b2
      "movw  r18, r6     \n\t"  //     1          noise = b0
      "add   r18, r8     \n\t"  //     1          noise += b1
      "adc   r19, r9     \n\t"  //     1          
      "add   r18, r10    \n\t"  //     1          noise += b2
      "adc   r19, r11    \n\t"  //     1          
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
                                // 20  level control  data:r19r18 * levelsg:r23r22 => d3:r15 d2:r13 d1:r14
      "mulsu r19, r23    \n\t"  //     2          levelsg_h
      "and   r3 , r3     \n\t"  //     1          if level256(XP[OtO):r3==1 
      "breq  1f          \n\t"  //     1  2             
      "mov   r14,  r1    \n\t"  //     1                
      "mov   r13,  r0    \n\t"  //     1                
      "mul   r18, r23    \n\t"  //     2                levelsg_h
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mulsu r19, r22    \n\t"  //     2                levelsg_l
      "sbc   r14,  r2    \n\t"  //     1                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mov   r15,  r14   \n\t"  //     1                d2 ̕Ƃ肾
      "add   r15,  r15   \n\t"  //     1                
      "sbc   r15,  r15   \n\t"  //     1                d3 = 
      "rjmp  2f          \n\t"  //     2                
      "1:                \n\t"  //                }else{      XP[OȂꍇ
      "movw  r14,  r0    \n\t"  //        1             
      "mul   r18, r22    \n\t"  //        2             levelsg_l
      "mov   r13,  r1    \n\t"  //        1             
      "mul   r18, r23    \n\t"  //        2             levelsg_h
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "mulsu r19, r22    \n\t"  //        2             levelsg_l
      "sbc   r15,  r2    \n\t"  //        1             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "2:                \n\t"  //                }
      
                                // 4  SW͂H
      "in    r21, 0x09   \n\t"  //     1          sw:r21=~(uint8)SW_PORT:0x09
      "com   r21         \n\t"  //     1
      "andi  r21, 0xE8   \n\t"  //     1          sw:r21 &= SW_MASK:0xE8
      "brne  99f         \n\t"  //     1  2       if( sw ) return
      
      "rjmp  90b         \n\t"  // 2         } jmp while(1)
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - while [v̏I
      "99:               \n\t"  //                return
      "clr   r1          \n\t"  // 1              r1=0 ɖ߂
      : 
      : "r"(paramsg)
      : "r0", "r1",               // |Ž
        "r2",                     // zero
        "r3",                     // level256
        "r4",                     // rndmulti
        "r5",                     // tmp
        "r7", "r6",               // b0
        "r9", "r8",               // b1
        "r11", "r10",             // b2
        "r15", "r14", "r13",      // d3, d2, d1
        "r17", "r16",             // rnd
        "r19", "r18",             // tmp noise
        "r21", "r20",             // tmp
        "r23", "r22",             // levelsg
        "r27", "r26",             // rnd8
        "r29",                    // tmp
        "r31", "r30"              // Z
  );
}


// ------------------------------------------------------------------------
// TwoTone eXg Pe[u Qjv  ʑZ19bit
// ------------------------------------------------------------------------
void twotone( void ) {
  asm volatile (                // 
      "movw  r30, %0     \n\t"  // 1          paramsg
      "ld    r3 , Z      \n\t"  // 2          r3 = level256
      "ldd   r20, Z+1    \n\t"  // 2          level
      "ldd   r21, Z+2    \n\t"  // 2          
      "clr   r9          \n\t"  // 1          phase1_h
      "clr   r8          \n\t"  // 1          phase1_m
      "clr   r7          \n\t"  // 1          phase1_l
      "ldd   r12, Z+14   \n\t"  // 2          phase2_h  1/FS␳Ȃ
      "ldd   r11, Z+13   \n\t"  // 2          phase2_m
      "clr   r10         \n\t"  // 1          phase2_l
      "clr   r2          \n\t"  // 1         { r1 [|ZŎĝ r2 [ƂĎg
      
      "90:               \n\t"  //           while(1) {
    
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - O   14 clk     k ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "sbi   0x0b, 2     \n\t"  // 2              LRCLK_H
      
                                // 10 ʑZ for Lch
      "movw  r30, %0     \n\t"  //     1          paramsg
      "ldd   r16, Z+4    \n\t"  //     2          freq1sg_l
      "add   r7 , r16    \n\t"  //     1          phase1:r9r8r7 += freq1sgh:+3 freq1sg:+5,+4
      "ldd   r16, Z+5    \n\t"  //     2          freq1sg_m
      "adc   r8 , r16    \n\t"  //     1          
      "ldd   r16, Z+3    \n\t"  //     2          freq1sg_h
      "adc   r9 , r16    \n\t"  //     1          
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - P   9 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14
      
                                // 7  PG o
      "mov   r30, r9     \n\t"  //     1          if( phaseh:r9 & 0x04 ) {
      "andi  r30, 0x04   \n\t"  //     1          
      "brne  1f          \n\t"  //     1  2       
      "cbi   0x05, 1     \n\t"  //     2             PG_H
      "rjmp  2f          \n\t"  //     2
      "1:                \n\t"  //                }else{
      "sbi   0x05, 1     \n\t"  //        2          PG_L;
      "nop               \n\t"  //        1
      "2:                \n\t"  //                }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - Q   15 clk
      "sts  0x00C6, r13  \n\t"  // 2              UDR0 = d1:r13
      
                                // 13 sin1:r5r4
      "mov   r30, r8     \n\t"  //     1          phase1h:r9r8 =  upper 11bits of phase
      "mov   r31, r9     \n\t"  //     1          
      "andi  r31, 0x07   \n\t"  //     1          Ȃrbg}XN
      "add   r30, r30    \n\t"  //     1          
      "adc   r31, r31    \n\t"  //     1          phase1h*2
      "add   r30, %A1    \n\t"  //     1          psin256h_tbl
      "adc   r31, %B1    \n\t"  //     1          
      "lpm   r4 , Z+     \n\t"  //     3          sin1:r5r4
      "lpm   r5 , Z      \n\t"  //     3          
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - R   26 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 10 ʑZ for Rch
      "movw  r30, %0     \n\t"  //     1          paramsg
      "ldd   r16, Z+7    \n\t"  //     2          freq2sg_l
      "add   r10, r16    \n\t"  //     1          phase2:r12r11r10 += freq2sgh:+6 freq2sg:+8,+7
      "ldd   r16, Z+8    \n\t"  //     2          freq2sg_m
      "adc   r11, r16    \n\t"  //     1          
      "ldd   r16, Z+6    \n\t"  //     2          freq2sg_h
      "adc   r12, r16    \n\t"  //     1          
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - S   4 clk     q ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "cbi   0x0b, 2     \n\t"  // 2              LRCLK_L;
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - T   21 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14     
      
                                // 13 sin2:r19r18
      "mov   r30, r11    \n\t"  //     1          phase2h:r12r11 =  upper 11bits of phase
      "mov   r31, r12    \n\t"  //     1          
      "andi  r31, 0x07   \n\t"  //     1          Ȃrbg}XN
      "add   r30, r30    \n\t"  //     1          
      "adc   r31, r31    \n\t"  //     1          phaseh*2
      "add   r30, %A1    \n\t"  //     1          psin256h_tbl
      "adc   r31, %B1    \n\t"  //     1          
      "lpm   r18, Z+     \n\t"  //     3          sin2:r19r18
      "lpm   r19, Z      \n\t"  //     3          
      
                                // 6  TCQgZ
      "asr   r5          \n\t"  //     1          sin1:r5r4/2
      "lsr   r4          \n\t"  //     1
      "asr   r19         \n\t"  //     1          sin2:r19r18/2
      "lsr   r18         \n\t"  //     1
      "add   r18, r4     \n\t"  //     1          data:r19r18 = sin1/2 + sin2/2
      "adc   r19, r5     \n\t"  //     1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - U   22 clk
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13 
      
                                // 20 level control
      "mulsu r19, r21    \n\t"  //     2                
      "and   r3 , r3     \n\t"  //     1          if level256(XP[OtO)==1 
      "breq  1f          \n\t"  //     1  2         XP[Oꍇ
      "mov   r14,  r1    \n\t"  //     1                
      "mov   r13,  r0    \n\t"  //     1                
      "mul   r18, r21    \n\t"  //     2                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mulsu r19, r20    \n\t"  //     2                
      "sbc   r14,  r2    \n\t"  //     1                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mov   r15,  r14   \n\t"  //     1                d2 ̕Ƃ肾
      "add   r15,  r15   \n\t"  //     1                
      "sbc   r15,  r15   \n\t"  //     1                d3 = 
      "rjmp  2f          \n\t"  //     2                
      "1:                \n\t"  //                }else{      XP[OȂꍇ
      "movw  r14,  r0    \n\t"  //        1             
      "mul   r18, r20    \n\t"  //        2             
      "mov   r13,  r1    \n\t"  //        1             
      "mul   r18, r21    \n\t"  //        2             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "mulsu r19, r20    \n\t"  //        2             
      "sbc   r15,  r2    \n\t"  //        1             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "2:                \n\t"  //                }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - V   17 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
                                // 4  SW͂H
      "in    r16, 0x09   \n\t"  //     1          sw:r21=~(uint8)SW_PORT:0x09
      "com   r16         \n\t"  //     1
      "andi  r16, 0xE8   \n\t"  //     1          sw:r21 &= SW_MASK:0xE8
      "brne  99f         \n\t"  //     1  2       if( sw ) return
      
      "rjmp  90b         \n\t"  // 2         } jmp while(1)
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - while [v̏I
      "99:               \n\t"  //                return
      "clr   r1          \n\t"  // 1              r1=0 ɖ߂
      : 
      : "r"(paramsg), "r"(psin2048_tbl) //, "a"(levelsg), "r"(freq1sg), "r"(freq1sgh), "r"(psin2048_tbl), "r"(freq2sg), "r"(freq2sgh)
      : "r0", "r1",               // |Ž
        "r2",                     // zero
        "r3",                     // level256
        "r5", "r4",               // tmp
        "r9", "r8", "r7",         // phase1
        "r12", "r11", "r10",      // phase2
        "r15", "r14", "r13",      // d3, d2, d1
        "r16",                    // tmp
        "r19", "r18",             // data
        "r21", "r20",             // level
        "r30", "r31"              // Z
  );
}



// ------------------------------------------------------------------------
// TC Qo  Pe[u Qjv  ʑZ19bit
// ------------------------------------------------------------------------
void sin2ch( void ) {
  asm volatile (                // 
      "movw  r30, %0     \n\t"  // 1          paramsg
      "ld    r3 , Z      \n\t"  // 2          r3 = level256
      "ldd   r20, Z+1    \n\t"  // 2          level
      "ldd   r21, Z+2    \n\t"  // 2          
      "clr   r9          \n\t"  // 1          phase1_h
      "clr   r8          \n\t"  // 1          phase1_m
      "clr   r7          \n\t"  // 1          phase1_l
      "ldd   r12, Z+10   \n\t"  // 2          phase2_h  1/FS␳
      "ldd   r11, Z+9    \n\t"  // 2          phase2_m
      "clr   r10         \n\t"  // 1          phase2_l
      "clr   r2          \n\t"  // 1         { r1 [|ZŎĝ r2 [ƂĎg
      
      "90:               \n\t"  //           while(1) {
    
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - O   8 clk     k ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "sbi   0x0b, 2     \n\t"  // 2              LRCLK_H
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - P   19 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14
      
                                // 10 ʑZ for Rch
      "movw  r30, %0     \n\t"  //     1          paramsg
      "ldd   r16, Z+7    \n\t"  //     2          freq2sg_l
      "add   r10, r16    \n\t"  //     1          phase2:r12r11r10 += freq2sgh:+6 freq2sg:+8,+7
      "ldd   r16, Z+8    \n\t"  //     2          freq2sg_m
      "adc   r11, r16    \n\t"  //     1          
      "ldd   r16, Z+6    \n\t"  //     2          freq2sg_h
      "adc   r12, r16    \n\t"  //     1          
      
                                // 7  PG o
      "mov   r30, r9     \n\t"  //     1          if( phaseh:r9 & 0x04 ) {
      "andi  r30, 0x04   \n\t"  //     1          
      "brne  1f          \n\t"  //     1  2       
      "cbi   0x05, 1     \n\t"  //     2             PG_H
      "rjmp  2f          \n\t"  //     2
      "1:                \n\t"  //                }else{
      "sbi   0x05, 1     \n\t"  //        2          PG_L;
      "nop               \n\t"  //        1
      "2:                \n\t"  //                }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - Q   15 clk
      "sts  0x00C6, r13  \n\t"  // 2              UDR0 = d1:r13
      
                                // 13  sin( phase2h ) => r19r18
      "mov   r30, r11    \n\t"  //     1          phase2h:r12r11 =  upper 11bits of phase
      "mov   r31, r12    \n\t"  //     1          
      "andi  r31, 0x07   \n\t"  //     1          Ȃrbg}XN
      "add   r30, r30    \n\t"  //     1          
      "adc   r31, r31    \n\t"  //     1          phaseh*2
      "add   r30, %A1    \n\t"  //     1          psin256h_tbl
      "adc   r31, %B1    \n\t"  //     1          
      "lpm   r18, Z+     \n\t"  //     3          sin( phaseh ):r19r18
      "lpm   r19, Z      \n\t"  //     3          
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - R   22 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 20 level control
      "mulsu r19, r21    \n\t"  //     2                
      "and   r3 , r3     \n\t"  //     1          if level256(XP[OtO)==1 
      "breq  1f          \n\t"  //     1  2         XP[Oꍇ
      "mov   r14,  r1    \n\t"  //     1                
      "mov   r13,  r0    \n\t"  //     1                
      "mul   r18, r21    \n\t"  //     2                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mulsu r19, r20    \n\t"  //     2                
      "sbc   r14,  r2    \n\t"  //     1                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mov   r15,  r14   \n\t"  //     1                d2 ̕Ƃ肾
      "add   r15,  r15   \n\t"  //     1                
      "sbc   r15,  r15   \n\t"  //     1                d3 = 
      "rjmp  2f          \n\t"  //     2                
      "1:                \n\t"  //                }else{      XP[OȂꍇ
      "movw  r14,  r0    \n\t"  //        1             
      "mul   r18, r20    \n\t"  //        2             
      "mov   r13,  r1    \n\t"  //        1             
      "mul   r18, r21    \n\t"  //        2             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "mulsu r19, r20    \n\t"  //        2             
      "sbc   r15,  r2    \n\t"  //        1             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "2:                \n\t"  //                }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - S   7 clk     q ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "cbi   0x0b, 2     \n\t"  // 2              LRCLK_L;
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - T   25 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14     
      
                                // 10 ʑZ for Lch
      "movw  r30, %0     \n\t"  //     1          paramsg
      "ldd   r16, Z+4    \n\t"  //     2          freq1sg_l
      "add   r7 , r16    \n\t"  //     1          phase1:r9r8r7 += freq1sgh:+3 freq1sg:+5,+4
      "ldd   r16, Z+5    \n\t"  //     2          freq1sg_m
      "adc   r8 , r16    \n\t"  //     1          
      "ldd   r16, Z+3    \n\t"  //     2          freq1sg_h
      "adc   r9 , r16    \n\t"  //     1          
      
                                // 13  sin( phase1h ) => r19r18
      "mov   r30, r8     \n\t"  //     1          phase1h:r9r8 =  upper 11bits of phase
      "mov   r31, r9     \n\t"  //     1          
      "andi  r31, 0x07   \n\t"  //     1          Ȃrbg}XN
      "add   r30, r30    \n\t"  //     1          
      "adc   r31, r31    \n\t"  //     1          phase1h*2
      "add   r30, %A1    \n\t"  //     1          psin256h_tbl
      "adc   r31, %B1    \n\t"  //     1          
      "lpm   r18, Z+     \n\t"  //     3          sin( phase1h ):r19r18
      "lpm   r19, Z      \n\t"  //     3          
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - U   4 clk
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13 
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - V   28 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 20 level control
      "mulsu r19, r21    \n\t"  //     2                
      "and   r3 , r3     \n\t"  //     1          if level256(XP[OtO)==1 
      "breq  1f          \n\t"  //     1  2         XP[Oꍇ
      "mov   r14,  r1    \n\t"  //     1                
      "mov   r13,  r0    \n\t"  //     1                
      "mul   r18, r21    \n\t"  //     2                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mulsu r19, r20    \n\t"  //     2                
      "sbc   r14,  r2    \n\t"  //     1                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mov   r15,  r14   \n\t"  //     1                d2 ̕Ƃ肾
      "add   r15,  r15   \n\t"  //     1                
      "sbc   r15,  r15   \n\t"  //     1                d3 = 
      "rjmp  2f          \n\t"  //     2                
      "1:                \n\t"  //                }else{      XP[OȂꍇ
      "movw  r14,  r0    \n\t"  //        1             
      "mul   r18, r20    \n\t"  //        2             
      "mov   r13,  r1    \n\t"  //        1             
      "mul   r18, r21    \n\t"  //        2             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "mulsu r19, r20    \n\t"  //        2             
      "sbc   r15,  r2    \n\t"  //        1             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "2:                \n\t"  //                }
      
                                // 4  SW͂H
      "in    r16, 0x09   \n\t"  //     1          sw:r21=~(uint8)SW_PORT:0x09
      "com   r16         \n\t"  //     1
      "andi  r16, 0xE8   \n\t"  //     1          sw:r21 &= SW_MASK:0xE8
      "brne  99f         \n\t"  //     1  2       if( sw ) return
      
      "rjmp  90b         \n\t"  // 2         } jmp while(1)
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - while [v̏I
      "99:               \n\t"  //                return
      "clr   r1          \n\t"  // 1              r1=0 ɖ߂
      : 
      : "r"(paramsg), "r"(psin2048_tbl) //, "a"(levelsg), "r"(freq1sg), "r"(freq1sgh), "r"(psin2048_tbl), "r"(freq2sg), "r"(freq2sgh)
      : "r0", "r1",               // |Ž
        "r2",                     // zero
        "r3",                     // level256
        "r9", "r8", "r7",         // phase1
        "r12", "r11", "r10",      // phase2
        "r15", "r14", "r13",      // d3, d2, d1
        "r17", "r16",             // sin
        "r19", "r18",             // data
        "r21", "r20",             // level
        "r30", "r31"              // Z
  );
}



// ------------------------------------------------------------------------
// ̑g`
// ------------------------------------------------------------------------
void etcwave( void ) {    // 1:square 2:saw 3:triangle
  asm volatile (                // 
      "ldi   r18, 0xFF   \n\t"  // 1              mask:r9r8 = 0x7FFF
      "ldi   r19, 0x7F   \n\t"  // 1              
      "movw  r8, r18     \n\t"  // 1              
      
                                //       19bitg16bitɕϊ
      "movw  r30, %0     \n\t"  // 1              r30:paramsg
      "ldd   r19, Z+3    \n\t"  // 2              tmp:r19=freq1sgh
      "ldd   r7 , Z+5    \n\t"  // 2              tmp:r7 =freq1sg_m
      "ldd   r6 , Z+4    \n\t"  // 2              tmp:r6 =freq1sg_l
      "ldi   r18, 0x20   \n\t"  // 1              0x20 |5bitVtg
      "mul   r19, r18    \n\t"  // 2              
      "mov   r2 , r0     \n\t"  // 1              
      "mul   r7 , r18    \n\t"  // 2              
      "or    r2 , r1     \n\t"  // 1              
      "mov   r7 , r2     \n\t"  // 1              
      "mov   r2 , r0     \n\t"  // 1              
      "mul   r6 , r18    \n\t"  // 2              
      "or    r2 , r1     \n\t"  // 1              
      "mov   r6 , r2     \n\t"  // 1              
      
      "ldd   r16, Z+1    \n\t"  // 2              r16:levelsg_l
      "ldd   r17, Z+2    \n\t"  // 2              r17:levelsg_h
      "ld    r20, Z      \n\t"  // 2              r20:level256
      
      "clr   r2          \n\t"  // 1              { r1 [ r1 |ZŎĝ r2 [ƂĎg
      
      "90:               \n\t"  //                while(1) {
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - O   16 clk     k ch
      "sbi   0x05, 0     \n\t"  // 2              TEST_H
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "sbi   0x0b, 2     \n\t"  // 2              LRCLK_H
      
                                // 2  ʑZ phase1:r11r10 += freq1sg:%3
      "add   r10, r6     \n\t"  //     1          freq1sg_l:r6
      "adc   r11, r7     \n\t"  //     1          freq1sg_h:r7
      
                                // 5  PG o
      "brmi  1f          \n\t"  //     1  2       
      "cbi   0x05, 1     \n\t"  //     2             PG_H
      "rjmp  2f          \n\t"  //     2
      "1:                \n\t"  //                }else{
      "sbi   0x05, 1     \n\t"  //        2          PG_L;
      "nop               \n\t"  //        1
      "2:                \n\t"  //                }
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - P   11 clk
      "cbi   0x05, 0     \n\t"  // 2              TEST_L
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14
      
      "movw  r18, r10    \n\t"  // 1              sawdata:r19r18 = phase:r11r10
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - Q   21 clk
      "sbi   0x05, 0     \n\t"  // 2              TEST_H
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13
      
                                // 17 Opg
      "movw  r22, r10    \n\t"  //     1             triangledata:r23r22 = phase & mask
      "andi  r23, 0x3F   \n\t"  //     1             
      "lsl   r22         \n\t"  //     1             Q{
      "rol   r23         \n\t"  //     1             
      "mov   r24, r11    \n\t"  //     1             quad:r24 = (uint8)(phase>>8:r11) & 0xC0
      "andi  r24, 0xC0   \n\t"  //     1             
      "cpi   r24, 0x40   \n\t"  //     1             
      "brne  1f          \n\t"  //     1     2       if( quad:r24==0x40 ) {
      "eor   r22, r8     \n\t"  //     1                triangledata = (triangledata ^ mask) + 1
      "eor   r23, r9     \n\t"  //     1                
      "subi  r22, 0xFF   \n\t"  //     1                
      "sbci  r23, 0xFF   \n\t"  //     1                
      "brpl  5f          \n\t"  //     1  2             if( minus ) {
      "ldi   r22, 0xFF   \n\t"  //     1                   triangledata = 0x7FFF
      "ldi   r23, 0x7F   \n\t"  //     1                   
      "rjmp  3f          \n\t"  //     2                   
      "5:                \n\t"  //                      }else{
      "nop               \n\t"  //        1                NOP
      "rjmp  3f          \n\t"  //        2             }
      "1:                \n\t"  //                    }else if( quad:r24==0x80 ) {
      "cpi   r24, 0x80   \n\t"  //           1          
      "brne  2f          \n\t"  //           1  2       
      "com   r23         \n\t"  //           1          triangledata = -triangledata
      "neg   r22         \n\t"  //           1          
      "sbci  r23, 0xFF   \n\t"  //           1          
      "nop               \n\t"  //           1          NOP
      "rjmp  3f          \n\t"  //           2          
      "2:                \n\t"  //                    }else if( quad==0xC0 ) {
      "cpi   r24, 0xC0   \n\t"  //              1       
      "brne  4f          \n\t"  //              1  2    
      "ori   r23, 0x80   \n\t"  //              1       triangledata |= 0x8000
      "rjmp  3f          \n\t"  //              2       
      "4:                \n\t"  //                    }else{
      "nop               \n\t"  //                 1    NOP
      "nop               \n\t"  //                 1    NOP
      "3:                \n\t"  //                    }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - R   16clk
      "cbi   0x05, 0     \n\t"  // 2              TEST_L
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 9  g`I
      "cpi   %1, 0x01    \n\t"  //     1  1  1  1     if( wave:%1 == 1 ) {
      "brne  1f          \n\t"  //     1  1  2  2
      "sbrs  r11, 7      \n\t"  //     2  1             if( phase:r11 & 0x8000 ) {
      "rjmp  2f          \n\t"  //        2
      "nop               \n\t"  //     1                  NOP;  
      "ldi   r18, 0xFF   \n\t"  //     1                  data:r19r18 = 32767; 
      "ldi   r19, 0x7F   \n\t"  //     1
      "rjmp  3f          \n\t"  //     2
      "2:                \n\t"  //                      }else{
      "ldi   r18, 0x01   \n\t"  //        1               data:r19r18 = -32767;  
      "ldi   r19, 0x80   \n\t"  //        1
      "rjmp  3f          \n\t"  //        2
      "1:                \n\t"  //                    }else if( wave:%1 == 3 ) {
      "cpi   %1, 0x03    \n\t"  //           1  1
      "brne  4f          \n\t"  //           1  2
      "nop               \n\t"  //           1          NOP;  
      "movw  r18, r22    \n\t"  //           1          data:r19r18 = triangledata:r23r22
      "rjmp  3f          \n\t"  //           2
      "4:                \n\t"  //                    }else{
      "nop               \n\t"  //              1       NOP;  
      "nop               \n\t"  //              1       NOP;  
      "nop               \n\t"  //              1       NOP;  
      "3:                \n\t"  //                    }
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - S   16clk     q ch
      "sbi   0x05, 0     \n\t"  // 2              TEST_H;   
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "cbi   0x0b, 2     \n\t"  // 2              LRCLK_L;
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - T   14 clk
      "cbi   0x05, 0     \n\t"  // 2              TEST_L;   
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - U   4 clk
      "sbi   0x05, 0     \n\t"  // 2              TEST_H;  
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - V   30 clk
      "cbi   0x05, 0     \n\t"  // 2              TEST_L
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 20  level control  data:r19r18 * levelsg:%1 => d3:r15 d2:r14 d1:r13
      "mulsu r19, r17    \n\t"  //     2          levelsg_h
      "and   r20, r20    \n\t"  //     1          if level256(XP[OtO)==1 
      "breq  1f          \n\t"  //     1  2             
      "mov   r14,  r1    \n\t"  //     1                
      "mov   r13,  r0    \n\t"  //     1                
      "mul   r18, r17    \n\t"  //     2                levelsg_h
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mulsu r19, r16    \n\t"  //     2                levelsg_l
      "sbc   r14,  r2    \n\t"  //     1                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mov   r15,  r14   \n\t"  //     1                d2 ̕Ƃ肾
      "add   r15,  r15   \n\t"  //     1                
      "sbc   r15,  r15   \n\t"  //     1                d3 = 
      "rjmp  2f          \n\t"  //     2                
      "1:                \n\t"  //                }else{      XP[OȂꍇ
      "movw  r14,  r0    \n\t"  //        1             
      "mul   r18, r16    \n\t"  //        2             levelsg_l
      "mov   r13,  r1    \n\t"  //        1             
      "mul   r18, r17    \n\t"  //        2             levelsg_h
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "mulsu r19, r16    \n\t"  //        2             levelsg_l
      "sbc   r15,  r2    \n\t"  //        1             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "2:                \n\t"  //                }
      
                                // 4  SW͂H
      "in    r24, 0x09   \n\t"  //     1          sw:r24=~(uint8)SW_PORT:0x09
      "com   r24         \n\t"  //     1
      "andi  r24, 0xE8   \n\t"  //     1          sw:r24 &= SW_MASK:0xE8
      "brne  99f         \n\t"  //     1  2       if( sw ) return
      
      "rjmp  90b         \n\t"  // 2         } jmp while(1)
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - I
      "99:               \n\t"  //                return
      "clr   r1          \n\t"  // 1              r1=0 ɖ߂
      : 
      : "r"(paramsg), "d"(pa.wave)
      : "r0", "r1", 
        "r2",                 // zero
        "r7", "r6",           // freq
        "r9", "r8",           // mask
        "r11", "r10",         // phase
        "r15", "r14", "r13",  // d3 d2 d1
        "r17", "r16",         // levelsg
        "r19", "r18",         // data
        "r20",                // levelsgh
        "r24",                // tmp quad sw
        "r23", "r22"          // triangledata
  );
}


// ------------------------------------------------------------------------
// ToneBurst g`
// ------------------------------------------------------------------------
void toneburst( void ) {
  asm volatile (                // 
      "movw  r30, %0     \n\t"  // 1          paramsg
      "ld    r3 , Z      \n\t"  // 2          r3 = level256
      "ldd   r20, Z+1    \n\t"  // 2          level
      "ldd   r21, Z+2    \n\t"  // 2          
      "ldd   r4 , Z+11   \n\t"  // 2          oncycle
      "ldd   r5 , Z+12   \n\t"  // 2          offcycle
      "clr   r9          \n\t"  // 1          phase1_h
      "clr   r8          \n\t"  // 1          phase1_m
      "clr   r7          \n\t"  // 1          phase1_l
      "clr   r2          \n\t"  // 1         { r1 [|ZŎĝ r2 [ƂĎg
      
      "90:               \n\t"  //           while(1) {
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - O   14 clk     k ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "sbi   0x0b, 2     \n\t"  // 2              LRCLK_H
                                // 10 ʑZ
      "movw  r30, %0     \n\t"  //     1          paramsg
      "ldd   r16, Z+4    \n\t"  //     2          freq1sg_l
      "add   r10, r16    \n\t"  //     1          phase1:r12r11r10 += freq1sgh:+3 freq1sg:+5,+4
      "ldd   r16, Z+5    \n\t"  //     2          freq1sg_m
      "adc   r11, r16    \n\t"  //     1          
      "ldd   r16, Z+3    \n\t"  //     2          freq1sg_h
      "adc   r12, r16    \n\t"  //     1          
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - P   15 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14
      
                                // 13 ʑ̕ςڂŃTCo͂邵Ȃ؂ւ
      "mov   r16, r12    \n\t"  //     1              
      "andi  r16, 0x08   \n\t"  //     1          if( phase_h & 0x08 )  // ʑ̕ςځH
      "breq  1f          \n\t"  //     1     2    {
      "dec   r6          \n\t"  //     1            if( --count:r6 )
      "breq  2f          \n\t"  //     1 2          {
      "nop               \n\t"  //     1               nop
      "nop               \n\t"  //     1               nop
      "nop               \n\t"  //     1               nop
      "nop               \n\t"  //     1               nop
      "nop               \n\t"  //     1               nop
      "nop               \n\t"  //     1               nop
      "rjmp  4f          \n\t"  //     2               
      "2:                \n\t"  //                  }else{  // JE^[[ɂȂ
      "and   r7 , r7     \n\t"  //       1            if( onoff )
      "breq  3f          \n\t"  //       1 2          {
      "clr   r7          \n\t"  //       1               onoff:r7 = 0;
      "mov   r6 , r5     \n\t"  //       1               count:r6 = offcycle:r5
      "nop               \n\t"  //       1               nop
      "rjmp  4f          \n\t"  //       2               
      "3:                \n\t"  //                    }else{        // onoff=1
      "inc   r7          \n\t"  //         1             onoff:r7 = 1;
      "mov   r6 , r4     \n\t"  //         1             count:r6 = oncycle:r4
      "rjmp  4f          \n\t"  //         2          }
                                //                  }
      "1:                \n\t"  //                }else{    // ʑ̕ςڂł͂Ȃ
      "nop               \n\t"  //           1      nop
      "nop               \n\t"  //           1      nop
      "nop               \n\t"  //           1      nop
      "nop               \n\t"  //           1      nop
      "nop               \n\t"  //           1      nop
      "nop               \n\t"  //           1      nop
      "nop               \n\t"  //           1      nop
      "nop               \n\t"  //           1      nop
      "nop               \n\t"  //           1      nop
      "4:                \n\t"  //                }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - Q   8 clk
      "sts  0x00C6, r13  \n\t"  // 2              UDR0 = d1:r13
      
                                // 6  PG o
      "and   r7 , r7     \n\t"  //     1          if( onoff )
      "breq  1f          \n\t"  //     1  2       {
      "sbi   0x05, 1     \n\t"  //     2             PG_H
      "rjmp  2f          \n\t"  //     2
      "1:                \n\t"  //                }else{ 
      "cbi   0x05, 1     \n\t"  //        2          PG_L;
      "nop               \n\t"  //        1
      "2:                \n\t"  //                }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - R   27 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
                                // 14  sin( phase2h ) => r19r18
      "mov   r30, r11    \n\t"  //     1          phase2h:r12r11 =  upper 11bits of phase
      "mov   r31, r12    \n\t"  //     1          
      "andi  r31, 0x07   \n\t"  //     1          Ȃrbg}XN
      "mov   r12, r31    \n\t"  //     1          ʑ̐؂ւڌô phase_h ɖ߂
      "add   r30, r30    \n\t"  //     1          
      "adc   r31, r31    \n\t"  //     1          phaseh*2
      "add   r30, %A1    \n\t"  //     1          psin256h_tbl
      "adc   r31, %B1    \n\t"  //     1          
      "lpm   r18, Z+     \n\t"  //     3          sin( phaseh ):r19r18
      "lpm   r19, Z      \n\t"  //     3          
      
                                // 5  o͂IIt
      "and   r7 , r7     \n\t"  //     1          if( onoff )
      "breq  1f          \n\t"  //     1  2       {
      "nop               \n\t"  //     1
      "rjmp  2f          \n\t"  //     2
      "1:                \n\t"  //                }else{ 
      "clr   r18         \n\t"  //        1
      "clr   r19         \n\t"  //        1
      "2:                \n\t"  //                }
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - S   4 clk     q ch
      "sts   0x00C6, r15 \n\t"  // 2              UDR0 = d3:r15
      "cbi   0x0b, 2     \n\t"  // 2              LRCLK_L;
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - T   22 clk
      "sts   0x00C6, r14 \n\t"  // 2              UDR0 = d2:r14     
      
                                // 20 level control
      "mulsu r19, r21    \n\t"  //     2                
      "and   r3 , r3     \n\t"  //     1          if level256(XP[OtO)==1 
      "breq  1f          \n\t"  //     1  2         XP[Oꍇ
      "mov   r14,  r1    \n\t"  //     1                
      "mov   r13,  r0    \n\t"  //     1                
      "mul   r18, r21    \n\t"  //     2                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mulsu r19, r20    \n\t"  //     2                
      "sbc   r14,  r2    \n\t"  //     1                
      "add   r13,  r1    \n\t"  //     1                
      "adc   r14,  r2    \n\t"  //     1                
      "mov   r15,  r14   \n\t"  //     1                d2 ̕Ƃ肾
      "add   r15,  r15   \n\t"  //     1                
      "sbc   r15,  r15   \n\t"  //     1                d3 = 
      "rjmp  2f          \n\t"  //     2                
      "1:                \n\t"  //                }else{      XP[OȂꍇ
      "movw  r14,  r0    \n\t"  //        1             
      "mul   r18, r20    \n\t"  //        2             
      "mov   r13,  r1    \n\t"  //        1             
      "mul   r18, r21    \n\t"  //        2             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "mulsu r19, r20    \n\t"  //        2             
      "sbc   r15,  r2    \n\t"  //        1             
      "add   r13,  r0    \n\t"  //        1             
      "adc   r14,  r1    \n\t"  //        1             
      "adc   r15,  r2    \n\t"  //        1             
      "2:                \n\t"  //                }
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - U   22 clk
      "sts   0x00C6, r13 \n\t"  // 2              UDR0 = d1:r13 
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - V   16 clk
      "sts   0x00C6, r2  \n\t"  // 2              UDR0 = 0
      
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      "nop               \n\t"  // 1
      
                                // 4  SW͂H
      "in    r16, 0x09   \n\t"  //     1          sw:r21=~(uint8)SW_PORT:0x09
      "com   r16         \n\t"  //     1
      "andi  r16, 0xE8   \n\t"  //     1          sw:r21 &= SW_MASK:0xE8
      "brne  99f         \n\t"  //     1  2       if( sw ) return
      
      "rjmp  90b         \n\t"  // 2         } jmp while(1)
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - while [v̏I
      "99:               \n\t"  //                return
      "clr   r1          \n\t"  // 1              r1=0 ɖ߂
      : 
      : "r"(paramsg), "r"(psin2048_tbl) //, "a"(levelsg), "r"(freq1sg), "r"(freq1sgh), "r"(psin2048_tbl), "r"(freq2sg), "r"(freq2sgh)
      : "r0", "r1",               // |Ž
        "r2",                     // zero
        "r3",                     // level256
        "r4",                     // oncycle
        "r5",                     // offcycle
        "r6",                     // count
        "r7",                     // onoff
        "r12", "r11", "r10",      // phase
        "r15", "r14", "r13",      // d3, d2, d1
        "r16",                    // tmp
        "r19", "r18",             // data
        "r21", "r20",             // level
        "r30", "r31"              // Z
  );
}


